/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelAbout = {};
panelAbout.localization = {};
/****************************/

// Panel details
panelAbout.panelName = "About";
panelAbout._panel = $("#pnl" + panelAbout.panelName);

// Localizations
panelAbout.localization = {
};

// Assign localizations
localizations.panels[panelAbout.panelName] = $.extend(panelAbout.localization, localizations.panels[panelAbout.panelName]);

// Interface methods
panelAbout.init = function(){
	applyLocalizations(panelAbout.panelName, localizations.panels);
	panelAbout.bindEvents();
	panelAbout.bindData();
}

panelAbout.bindData = function()
{
	var serverInfo = adminPanel.storage("serverInfo");
	if(serverInfo)
	{
		adminPanel.data.bindValuesFromJson(panelAbout._panel, serverInfo);
		if (serverInfo.enterprise_level*1 > 0) $("#enterprise_level", panelAbout._panel).text("Enterprise Level: "+serverInfo.enterprise_level);
		if($("#enterprise_level", panelAbout._panel).text() == "0")
			$("#enterprise_level", panelAbout._panel).hide();
		else
			$("#enterprise_level", panelAbout._panel).show();

		if (serverInfo.max_max_users == "32768") $("#max_max_users", panelAbout._panel).text("unlimited");
		else if (serverInfo.max_max_users == "5")
		{
			$("#registration_name", panelAbout._panel).text("Unregistered");
			$("#registration_email", panelAbout._panel).text("30 Day Trial");
		}

		$("#server_current_version", panelAbout._panel).text(serverInfo.version_info_str + serverInfo.sub_version_info_str);

		if(serverInfo.update_available == "true")
		{
			$("#newUpdateAvailable", panelAbout._panel).show();
			$("#noNewVersion", panelAbout._panel).hide();
			if(!adminPanel.updateNotificationShown)
			{
				adminPanel.updateNotificationShown = true;
				adminPanel.UI.growl("Update available", "New version available : " + serverInfo.update_available_version + "<div style='margin:10px;text-align:right;'>" + "<a href='#' id='growlUpdateShowInfo'>Show Details</a> | <a href='#' id='growlUpdateNow'>Update Now</a></div>", false);
				$("#growlUpdateShowInfo").click(function(){
					$("#configOptionTabs").tabs({selected:3});
					$("#showNewVersionDetails", panelAbout._panel).trigger("click");
					$(this).closest(".ui-notify").find(".ui-notify-close").trigger("click");
					return false;
				});
				$("#growlUpdateNow").click(function(){
					$("#configOptionTabs").tabs({selected:3});
					$(".updateCrushFTP:first", panelAbout._panel).trigger("click");
					$(this).closest(".ui-notify").find(".ui-notify-close").trigger("click");
					return false;
				});
			}
		}
		else
		{
			$("#newUpdateAvailable", panelAbout._panel).hide();
			$("#noNewVersion", panelAbout._panel).show();
		}
	}
	else
	{
		panelAbout._panel.block({
			message:  'Wait..',
			css: {
				border: 'none',
				padding: '0px 10px',
				backgroundColor: '#000',
				'-webkit-border-radius': '10px',
				'-moz-border-radius': '10px',
				opacity: .5,
				color: '#fff',
				'text-align':'left'
			}
		});

		adminPanel.dataRepo.refreshServerInfo(function(items){
			panelAbout._panel.unblock();
			if(items)
			{
				panelAbout.bindData();
			}
		});
	}
}

panelAbout.refreshInfoFromServer = function()
{
	adminPanel.UI.showIndicator(false, false, "Please wait..");
	adminPanel.dataRepo.refreshServerInfo(function(items){
		panelAbout.bindData();
		$(".enterpriseFeature").hide();
		$("#SessionSeconds").sessionChecker({
			refreshServerInfo : true,
			callBack:function(){
				if (($(document).data("crushftp_version")+"").indexOf("6") >= 0) //show new features
				{
					if (($(document).data("crushftp_enterprise")+"") * 1 > 0) //show new features
					{
						$(".enterpriseFeature").show();
					}
				}
				adminPanel.UI.hideIndicator();
			}
		});
	});
}

panelAbout.bindEvents = function()
{
	$("#updateProgressPanel").dialog({
		autoOpen: false,
		minHeight: 150,
		width: 400,
		modal: true,
		resizable: false,
		title : "Update in progress : ",
		closeOnEscape: false,
		open : function(event, ui){
			$("#cancelUpdate").blur();
			$("#updateProgressPanel").closest(".ui-dialog").find(".ui-dialog-titlebar-close").remove();
		}
	});

	panelAbout.serverRestartingDialog = $("#serverRestartingDialog").dialog({
		autoOpen: false,
		height: 150,
		width: 440,
		modal: true,
		resizable: false,
		title : "Server restarting : ",
		closeOnEscape: false,
		open : function(event, ui){
			panelAbout.serverRestartingDialog.closest(".ui-dialog").find(".ui-dialog-titlebar-close").remove();
		}
	});

	$("#registrationDialog").dialog({
		autoOpen: false,
		height: 240,
		width: 450,
		modal: true,
		resizable: false,
		title : "CrushFTP Registration : ",
		closeOnEscape: false,
		open: function(){
			$("#registrationDialog_registration_name").focus().select();
		}
	});

	$("#registerCrushFTP", panelAbout._panel).unbind().click(function(){
		$("#registrationDialog").dialog("open");
		return false;
	});

	$("#registerCrushFTPAction").unbind().click(function(){
		var registrationDialog = $("#registrationDialog");
		var name = $("#registrationDialog_registration_name", registrationDialog).val();
		var email = $("#registrationDialog_registration_email", registrationDialog).val();
		var code = $("#registrationDialog_registration_code", registrationDialog).val();
		if(name.length == 0 || email.length == 0 || code.length == 0)
		{
			jAlert("All fields are required", "Error", function(){
				if(name.length == 0)
				{
					$("#registrationDialog_registration_name", registrationDialog).focus().select();
				}
				else if(email.length == 0)
				{
					$("#registrationDialog_registration_email", registrationDialog).focus().select();
				}
				else
				{
					$("#registrationDialog_registration_code", registrationDialog).focus().select();
				}
			});
		}
		else if(!adminPanel.methods.isValidEmail(email))
		{
			jAlert("Please enter vaild email address", "Error", function(){
				$("#registrationDialog_registration_email", registrationDialog).focus().select();
			});
		}
		else
		{
			adminPanel.data.serverRequest({
				command: "registerCrushFTP",
				registration_name : encodeURIComponent(name),
				registration_email : encodeURIComponent(email),
				registration_code : encodeURIComponent(code)
			},
			function(data){
				var items = false;
				if(data)
				{
					if($(data).length > 0)
					{
						data = $(data).text();
						jAlert(data, "Message", function(){
							if(data == "Registration Information Accepted")
							{
								$("#registrationDialog").dialog("close");
								$("#registrationDialog").clearForm();
								panelAbout.refreshInfoFromServer();
							}
							else
							{
								$("#registrationDialog_registration_name", registrationDialog).focus().select();
							}
						});
					}
				}
			}, "POST");
		}
		return false;
	});

	$("#cancelRegistration").unbind().click(function(){
		$("#registrationDialog").dialog("close");
		return false;
	});

	$("#updateDialog").dialog({
		autoOpen: false,
		height: 420,
		width: 500,
		modal: true,
		resizable: false,
		title : "CrushFTP Update :",
		closeOnEscape: false
	});

	$("#checkForUpdateCrushFTPAction", panelAbout._panel).unbind().click(function(){
		panelAbout.refreshInfoFromServer();
		return false;
	});

	$("#showNewVersionDetails", panelAbout._panel).unbind().click(function(){
		var updateDialog = $("#updateDialog");
		$("#new_version_no", updateDialog).text($("#update_available_version").text());
		$("#new_version_html", updateDialog).html($("#update_available_html").val());
		updateDialog.dialog("open");
		return false;
	});

	$(".updateCrushFTP").unbind().click(function(){
		if(!panelAbout.updateRunning)
		{
			adminPanel.data.serverRequest({
				command: "updateNow"
			},
			function(data){
				panelAbout.checkUpdateProgress(true);
			}, "POST");
		}
		$("#updateDialog").dialog("close");
		return false;
	});

	$("#cancelUpdate").unbind().click(function(){
		if(panelAbout.updateRunning)
		{
			jConfirm("Are you sure you wish to cancel update process?", "Confirm", function(flag)
			{
				if(flag)
				{
					adminPanel.data.serverRequest({
						command: "cancelUpdateProgress"
					},
					function(data){
						adminPanel.UI.growl("Update canceled", "Updated was canceled, you can update to latest version from 'About' tab.", false, 5000);
						panelAbout.showHideUpdateProgress();
					}, "POST");
					panelAbout.updateRunning = false;
				}
			});
		}
		return false;
	});

	$("#closeUpdateWindow").unbind().click(function(){
		$("#updateDialog").dialog("close");
		return false;
	});

	var serverInfo = adminPanel.storage("serverInfo");
	if(serverInfo && serverInfo.machine_is_windows && serverInfo.machine_is_windows.toString() != "true")
	{
		$(".windowsOnly", panelAbout.serverRestartingDialog).remove();
	}
};

panelAbout.checkUpdateProgress = function(init)
{
	if(panelAbout.updateProgressCallRunning) return false;
	if(init)
	{
		panelAbout.updateRunning = true;
		panelAbout.lastUpdateLocation = 0;
		panelAbout.showHideUpdateProgress();
		$("#updateProgressbar").removeData("history");
	}
	panelAbout.updateProgressCallRunning = true;
	adminPanel.data.serverRequest({
		command: "updateNowProgress"
	},
	function(data){
		panelAbout.updateProgressCallRunning = false;
		var items = $.xml2json(data);
		var updateProgress = false;
		if(items && items.response)
		{
			var currentLoc = parseInt(items.response.currentLoc);
			var maximumLoc = parseInt(items.response.maximumLoc);
			if(currentLoc<maximumLoc)
			{
				panelAbout.lastUpdateLocation = currentLoc;
				panelAbout.updateProgressbar(currentLoc, maximumLoc);
				setTimeout(function(){
					if(panelAbout.updateRunning)
						panelAbout.checkUpdateProgress();
				}, 1000);
				updateProgress = true;
			}
		}
		if(!updateProgress)
		{
			panelAbout.updateRunning = false;
			panelAbout.showHideUpdateProgress();
			adminPanel.UI.growl("Update completed", "Successfully updated to latest version, please wait while server restarts.", false, 5000);
			panelAbout.pollServerInfo(30000);
		}
	}, "POST");
}

panelAbout.pollServerInfo = function(interval)
{
	if(!panelAbout.serverRestartingDialog.dialog("isOpen"))
	{
		if($(".windowsOnly", panelAbout.serverRestartingDialog).length==0)
		{
			panelAbout.serverRestartingDialog.dialog({
				height:90
			});
		}
		panelAbout.serverRestartingDialog.dialog("open");
		panelAbout.pollingTries = 0;
	}
	interval = interval || 100;
	setTimeout(function(){
		adminPanel.dataRepo.refreshServerInfo(function(items){
			if(items)
			{
				panelAbout.serverRestartingDialog.dialog("close");
				panelAbout.bindData();
				adminPanel.UI.growl("Server started", "Server is up and running, current version is : " + $("#server_current_version").text(), false, 5000);
			}
			else
			{
				panelAbout.pollingTries += 1;
				if(panelAbout.pollingTries > 20)
				{
					adminPanel.UI.growl("Refreshing page", "Too many tries to contacting server, refreshing page", true, 5000);
					setTimeout(function(){
						window.location = window.location;
					}, 5000);
				}
				else
				{
					setTimeout(function(){
						panelAbout.pollServerInfo();
					}, 1000);
				}
			}
		});
	}
	, interval);
};

panelAbout.updateProgressbar = function(cur, max)
{
	var perc = 0;
	var updateProgressbar = $("#updateProgressbar");
	if(max>0)
	{
		perc = Math.round((cur * 100)/max);
	}
	var updateProgressText = "Getting file size information...";
	if(cur > 0)
	{
		var downloaded = adminPanel.methods.formatBytes(cur);
		var toDownload = adminPanel.methods.formatBytes(max);

		var now = new Date().getTime();
		if (!$(updateProgressbar).data("history")) $(updateProgressbar).data("history", new Array());
		var history = $(updateProgressbar).data("history");
		history.push({
			now: now,
			bytes: cur
		});
		var pivot = 0;
		if (history.length > 5) {
			pivot = history.length - 5;
		}
		var elapsed = now - history[0].now;
		var bytes = cur - history[pivot].bytes;
		var lastElapsed = now - history[pivot].now;
		var originalBytes = cur - history[0].bytes;
		var secs = ((((max - cur) / (originalBytes / elapsed)) / 1000) + 1) + "";
		var remaining = adminPanel.methods.formatTime(secs);
		var elapsedFormatted = adminPanel.methods.formatTime((elapsed / 1000) + 1 + "");
		var avgSpeed = adminPanel.methods.formatBytes((originalBytes / elapsed) * 1024.0);
		avgSpeed = avgSpeed ? avgSpeed + "/s" : "Calcualting..";
		elapsedFormatted = elapsedFormatted ||  "Calcualting..";
		remaining = remaining ||  "Calcualting..";
		updateProgressText = "<div>Avg. Download Speed : <span class='ui-priority-primary'>" + avgSpeed + "</span></div><div>Downloaded <span class='ui-priority-primary'>" + downloaded + "</span> of Total <span class='ui-priority-primary'>" + toDownload + "</span>" + "</div><div>Time Elapsed : <span class='ui-priority-primary'>" + elapsedFormatted + "</span></div><div>Time Remaining : <span class='ui-priority-primary'>" + remaining + "</span></div>";
	}
	$("#updateProgressText").html(updateProgressText);
	updateProgressbar.progressbar({
		value: perc
	});
	$("#ui-dialog-title-updateProgressPanel").text("Update in progress : " + perc + "%");
}

panelAbout.tabShown = function()
{
	panelAbout.showHideUpdateProgress();
}

panelAbout.showHideUpdateProgress = function(flag)
{
	flag = flag || panelAbout.updateRunning;
	if(flag)
	{
		$("#updateProgressPanel").dialog("open");
	}
	else
	{
		$("#updateProgressPanel").dialog("close");
	}
};